package techreborn.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import reborncore.common.container.RebornContainer;
import techreborn.client.container.ContainerCentrifuge;
import techreborn.client.container.ContainerGrinder;
import techreborn.tiles.TileCentrifuge;

public class GuiCentrifuge extends GuiContainer
{

	public static final ResourceLocation texture = new ResourceLocation("techreborn",
			"textures/gui/industrial_centrifuge.png");

	TileCentrifuge centrifuge;

	public GuiCentrifuge(EntityPlayer player, TileCentrifuge tileCentrifuge)
	{
		super(RebornContainer.createContainer(ContainerCentrifuge.class, tileCentrifuge, player));
		this.field_146999_f = 176;
		this.field_147000_g = 167;
		centrifuge = tileCentrifuge;
	}

	@Override
	public void func_73866_w_()
	{
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		super.func_73866_w_();
	}

	@Override
	protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_)
	{
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

		int j = centrifuge.getProgressScaled(11);
		if (j > 0)
		{
			this.func_73729_b(k + 83, l + 23 + 10 - j, 177, 15 + 10 - j, 10, j);
			this.func_73729_b(k + 98, l + 38, 177, 51, j, 10);
			this.func_73729_b(k + 83, l + 53, 177, 39, 10, j);
			this.func_73729_b(k + 68 + 10 - j, l + 38, 177 + 10 - j, 27, j, 10);
		}

		j = (int)(centrifuge.getEnergy() * 12f / centrifuge.getMaxPower());
		if (j > 0) {
			this.func_73729_b(k + 9, l + 32 + 12 - j, 176, 12 - j, 14, j + 2);
		}
	}

	protected void func_146979_b(int p_146979_1_, int p_146979_2_)
	{
		String namePt1 = I18n.func_74838_a("tile.techreborn.industrialBlock.name");
		String namePt2 = I18n.func_74838_a("tile.techreborn.centrifuge.name").replace(namePt1 + " ", "");
		this.field_146289_q.func_78276_b(namePt1, 98, 6, 4210752);
		this.field_146289_q.func_78276_b(namePt2, 98, 14, 4210752);
		this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory", new Object[0]), 8,
				this.field_147000_g - 96 + 2, 4210752);
		this.field_146289_q.func_78276_b(centrifuge.getProgressScaled(100) + "%", 98, this.field_147000_g - 96 + 2, 4210752);
	}
}
