package techreborn.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.translation.I18n;
import reborncore.common.container.RebornContainer;
import techreborn.client.container.ContainerGrinder;
import techreborn.tiles.teir1.TileGrinder;

public class GuiGrinder extends GuiContainer
{

	public static final ResourceLocation texture = new ResourceLocation("techreborn", "textures/gui/grinder.png");

	TileGrinder grinder;
	ContainerGrinder containerGrinder;

	public GuiGrinder(EntityPlayer player, TileGrinder tilegrinder)
	{
		super(RebornContainer.createContainer(ContainerGrinder.class, tilegrinder, player));
		this.field_146999_f = 176;
		this.field_147000_g = 167;
		this.grinder = tilegrinder;
		containerGrinder = (ContainerGrinder) this.field_147002_h;
	}

	@Override
	protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_)
	{
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		this.field_146297_k.func_110434_K().func_110577_a(texture);
		int k = (this.field_146294_l - this.field_146999_f) / 2;
		int l = (this.field_146295_m - this.field_147000_g) / 2;
		this.func_73729_b(k, l, 0, 0, this.field_146999_f, this.field_147000_g);

		int j = 0;

		j = grinder.getProgressScaled(24);
		if (j > 0)
		{
			this.func_73729_b(k + 80, l + 36, 176, 14, j + 1, 16);
		}

		j = (int)(grinder.getEnergy() * 12f / grinder.getMaxPower());
		if (j > 0) {
			this.func_73729_b(k + 24, l + 36 + 12 - j, 176, 12 - j, 14, j + 2);
		}
	}

	protected void func_146979_b(int p_146979_1_, int p_146979_2_)
	{
		String name = I18n.func_74838_a("tile.techreborn.grinder.name");
		this.field_146289_q.func_78276_b(name, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(name) / 2, 6,
				4210752);
		this.field_146289_q.func_78276_b(I18n.func_74837_a("container.inventory", new Object[0]), 8,
				this.field_147000_g - 96 + 2, 4210752);
	}

}
