package techreborn.client.hud;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.client.event.RenderGameOverlayEvent.ElementType;
import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.opengl.GL11;

import reborncore.api.power.IEnergyInterfaceItem;
import reborncore.common.powerSystem.PowerSystem;
import reborncore.common.util.Color;
import techreborn.client.keybindings.KeyBindings;
import techreborn.config.ConfigTechReborn;

public class ChargeHud
{
	public static final ChargeHud instance = new ChargeHud();
	public static KeyBindings key;
	public static boolean showHud = true;
	private static Minecraft mc = Minecraft.func_71410_x();

	@SideOnly(Side.CLIENT)
	@SubscribeEvent(priority = EventPriority.LOW)
	public void onRenderExperienceBar(RenderGameOverlayEvent event)
	{
		if (key.config.func_151468_f())
		{
			showHud = !showHud;
		}

		if (event.isCancelable() || event.getType() != ElementType.ALL)
			return;

		if (mc.field_71415_G || (mc.field_71462_r != null && mc.field_71474_y.field_74330_P))
		{
			if (ConfigTechReborn.ShowChargeHud)
				drawChargeHud(event.getResolution());
		}
	}

	public void drawChargeHud(ScaledResolution res)
	{
		EntityPlayer player = mc.field_71439_g;
		ItemStack armorstack = player.func_184582_a(EntityEquipmentSlot.CHEST);
		ItemStack offHandstack = player.func_184582_a(EntityEquipmentSlot.OFFHAND);
		ItemStack stack = mc.field_71439_g.field_71071_by.func_70448_g();

		int y = 5;

		if (armorstack != null && ConfigTechReborn.ShowChargeHud
				&& armorstack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			double MaxCharge = ((IEnergyInterfaceItem) armorstack.func_77973_b()).getMaxPower(armorstack);
			double CurrentCharge = ((IEnergyInterfaceItem) armorstack.func_77973_b()).getEnergy(armorstack);
			Color color = Color.GREEN;
			double quarter = MaxCharge / 4;
			double half = MaxCharge / 2;
			GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
			GL11.glEnable(32826);
			RenderHelper.func_74519_b();
			RenderHelper.func_74520_c();
			// Render the stack
			renderItemStack(armorstack, 0, y - 5);
			// Get the color depending on current charge
			if (CurrentCharge <= half)
			{
				color = Color.YELLOW;
			}
			if (CurrentCharge <= quarter)
			{
				color = Color.DARK_RED;
			}
			mc.field_71466_p.func_78276_b(color + PowerSystem.getLocalizedPower(CurrentCharge) + "/"
					+ PowerSystem.getLocalizedPower(MaxCharge), 20, y, 0);
			y += 20;
		}

		if (showHud)
		{
			if (offHandstack != null && offHandstack.func_77973_b() instanceof IEnergyInterfaceItem)
			{
				double MaxCharge = ((IEnergyInterfaceItem) offHandstack.func_77973_b()).getMaxPower(offHandstack);
				double CurrentCharge = ((IEnergyInterfaceItem) offHandstack.func_77973_b()).getEnergy(offHandstack);
				if(MaxCharge != 0){
					Color color = Color.GREEN;
					double quarter = MaxCharge / 4;
					double half = MaxCharge / 2;
					GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
					GL11.glEnable(32826);
					RenderHelper.func_74519_b();
					RenderHelper.func_74520_c();
					renderItemStack(offHandstack, 0, y - 5);
					if (CurrentCharge <= half)
					{
						color = Color.YELLOW;
					}
					if (CurrentCharge <= quarter)
					{
						color = Color.DARK_RED;
					}
					mc.field_71466_p.func_78276_b(color + PowerSystem.getLocalizedPower(CurrentCharge) + "/"
							+ PowerSystem.getLocalizedPower(MaxCharge), 20, y, 0);
					y += 20;
				}
			}
			if (stack != null && stack.func_77973_b() instanceof IEnergyInterfaceItem)
			{
				double MaxCharge = ((IEnergyInterfaceItem) stack.func_77973_b()).getMaxPower(stack);
				double CurrentCharge = ((IEnergyInterfaceItem) stack.func_77973_b()).getEnergy(stack);
				Color color = Color.GREEN;
				double quarter = MaxCharge / 4;
				double half = MaxCharge / 2;
				GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
				GL11.glEnable(32826);
				RenderHelper.func_74519_b();
				RenderHelper.func_74520_c();
				renderItemStack(stack, 0, y - 5);
				if (CurrentCharge <= half)
				{
					color = Color.YELLOW;
				}
				if (CurrentCharge <= quarter)
				{
					color = Color.DARK_RED;
				}
				mc.field_71466_p.func_78276_b(color + PowerSystem.getLocalizedPower(CurrentCharge) + "/" + PowerSystem.getLocalizedPower(MaxCharge), 20, y, 0);
			}
		}
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
	}

	public void renderItemStack(ItemStack stack, int x, int y)
	{
		if (stack != null)
		{
			GL11.glEnable(GL11.GL_BLEND);
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
			RenderHelper.func_74520_c();

			RenderItem itemRenderer = Minecraft.func_71410_x().func_175599_af();
			itemRenderer.func_180450_b(stack, x, y);

			GL11.glDisable(GL11.GL_LIGHTING);
		}
	}

}
